import aiinterface.AIInterface;
import aiinterface.CommandCenter;

import enumerate.State;
import enumerate.Action;

import struct.CharacterData;
import struct.FrameData;
import struct.GameData;
import struct.Key;

import java.util.Random;

import java.util.LinkedList;

public class MuryFajarAI implements AIInterface {

	private FrameData fd;
	private GameData gd;
	private Key key;
	private CommandCenter com;
	
	private boolean player;

	private CharacterData myChar;
	private CharacterData enemy; 
	private State curState;  
	
	private boolean canUseSkill;
	private boolean isNear;
	private int minEnergy = 30;
	private boolean setupHp = false;
	private int currHpP1 = 0;
	private int curCond = 0; // 0 = neutral, 1 = move, 2 = guard, 3 = attack 
	
	private Random rnd;
	
	private Action act;
	
	private LinkedList<Node> listCombos;
	private Node currentCombos;
	private int maxListCombos = 25;
	
	private boolean playerGetHit;  
	private boolean playerHitSuccess;
	
	private Action[] attackGround;
	private Action[] attackAir;
	
	private Action[] moveForward;
	private Action[] moveBackward;
	private Action[] guardAction;
	private Action spSkill;
	
	
	Action actBefore;
	int indexCurComb = 0;
	int currentComboUse = 0;
	
	boolean reachMaxListCombo = false;
	
	@Override
	public int initialize(GameData gameData, boolean playerNum) {
		
		this.player = playerNum;
		this.gd = gameData;
		
		this.key = new Key();
		this.fd =  new FrameData();
		this.com = new CommandCenter();
		
		this.rnd = new Random();
		
		this.listCombos = new LinkedList<Node>();
		this.currentCombos =  new Node();
		
		playerGetHit = false;
		playerHitSuccess = false;
		
		
		curCond = 0;
		

		
		attackAir = new Action[] { 
				Action.AIR_A, Action.AIR_B, Action.AIR_DA, Action.AIR_DB, Action.AIR_FA, Action.AIR_FB, 
				Action.AIR_UA, Action.AIR_UB, Action.AIR_D_DF_FA, Action.AIR_D_DF_FB,
				Action.AIR_F_D_DFA, Action.AIR_F_D_DFB, Action.AIR_D_DB_BA, Action.AIR_D_DB_BB };
		
		attackGround = new Action[] { 
				Action.STAND_A, Action.STAND_B, Action.STAND_D_DB_BA, Action.THROW_A, 
				Action.THROW_B, Action.CROUCH_A, Action.CROUCH_B, Action.STAND_FA,
				Action.STAND_FB, Action.CROUCH_FA, Action.CROUCH_FB, Action.STAND_D_DF_FA, Action.STAND_D_DF_FB,
				Action.STAND_F_D_DFA, Action.STAND_F_D_DFB, Action.STAND_D_DB_BB
		};
		
		moveForward = new Action[] {Action.FORWARD_WALK, Action.DASH, Action.JUMP,  };
		moveBackward = new Action[] {Action.BACK_STEP, Action.BACK_JUMP, Action.JUMP };
		guardAction = new Action[] {Action.AIR_GUARD, Action.CROUCH_GUARD, Action.STAND_GUARD};
		
		spSkill = Action.STAND_D_DF_FC;
		
		return 0;
	}

	
	@Override
	public void getInformation(FrameData frameData, boolean isControl) {

		fd = frameData;
		com.setFrameData(fd, player);
		
		myChar = fd.getCharacter(player);
		enemy = fd.getCharacter(!player);
		
	}
	
	@Override
	public Key input() {
		return key;
	}

	

			
	@Override
	public void processing() {
		
		if(canProcessing()) {
			
			if(!setupHp) {
				currHpP1 = myChar.getHp();
			} else {
				if(currHpP1 < myChar.getHp()) {
					playerGetHit = true;
					currHpP1 = myChar.getHp();
				} else {
					playerGetHit = false;
				}
			}
			
			if(myChar.isHitConfirm()) {
				playerHitSuccess = true;
				
				if(!isReachMaxListCombo()) {
					if(currentCombos.use) {
						if(canAddtoCombo()) {
							currentCombos.Actions.add(actBefore);
							currentCombos.totalHit +=1;
							System.out.println("addCombo");
						}
					}
				}
				
			}
			
			if(com.getSkillFlag()) {
				key = com.getSkillKey();
				
			} else {
				key.empty();
				
				checkDistanceX();
				checkSkill();
				stateChar();
				
				act = Action.CROUCH_GUARD;
				
				if(isNear) {
					if(playerGetHit) {
						//dummy
						playerGetHit = false;
						int rand = rnd.nextInt(moveBackward.length - 1);
						act = moveBackward[rand];
						if(!isReachMaxListCombo()) {
							addNewCombo();
						} else {
							//use a new combo
							prepareNewCombo();
							act = currentCombos.Actions.get(indexCurComb);
						}
					} 
					else {
						
						if(currentCombos.Actions.size() == 0) {
							// new combos
							int rand = rnd.nextInt(attackGround.length - 1);
							act = attackGround[rand];
							actBefore  = act;
							currentCombos.use = true;
						} 
						else {
							if(playerHitSuccess) {
								//continue current combos
								playerHitSuccess = false;
								if(!isReachMaxListCombo()) {
									// add new action for combos
									int rand = rnd.nextInt(attackGround.length - 1);
									act = attackGround[rand];
								} 
								else { 
									// use list combos
									if(indexCurComb < currentCombos.Actions.size()) {
										indexCurComb+=1;
										act = currentCombos.Actions.get(indexCurComb);
									}
									
								} 

								actBefore  = act;
							} 
							else {
								// cancel combos;
								
								if(!isReachMaxListCombo()) {
									//add new combos in list when getting hit
									int rand = rnd.nextInt(guardAction.length - 1);
									act = guardAction[rand];									
									
									currentCombos.Actions.add(actBefore);
									addNewCombo();
								} 
								else {
									
									// use potential combo from list combos									
									prepareNewCombo();
									act = currentCombos.Actions.get(indexCurComb);
									
								}
								actBefore  = act;
							}
							
						}
						
					}
				} 
				else {
					
					int num1 = rnd.nextInt(10);
					int num2 = rnd.nextInt(moveForward.length - 1);
					if(num1 % 2 == 0) {
						if(!canUseSkill) {
							act = moveForward[num2];		
						}
					} 
					else {
						act = moveForward[num2];
					}
					
				}
				
				
				com.commandCall(act.name());
				//System.out.println(act.name());
			}
		}
		

	}
	
	public boolean canAddtoCombo() {
		
		if(listCombos.size() == 0) {
			return true;
		}
		
		for(int i = 0; i < listCombos.size();i++) {
			if(currentCombos.Actions.size() == listCombos.get(i).Actions.size()) {
				for(int j = 0; j < listCombos.size(); j++) {
					if(currentCombos.Actions.get(j) != listCombos.get(i).Actions.get(j)) {

						return true;
					}
				}
			}
		}
		
		return false;
	}
	
	public void addNewCombo() {
		if(currentCombos.Actions.size()>1) {
			currentCombos.use = false;					
			listCombos.add(currentCombos);
		}
		currentCombos = new Node();
	}
	
	
	public void prepareNewCombo() {
		if(!reachMaxListCombo) {
			reachMaxListCombo = true;
		}
		
		//reached max list for combo list, search combos that have max potential hit
		currentComboUse = potentialCombos();
		currentCombos = null;
		listCombos.get(currentComboUse).use = true;
		currentCombos = listCombos.get(currentComboUse);
	}
	
	public boolean isReachMaxListCombo() {
		if(maxListCombos >= listCombos.size()) {
			return false;
		} else {
			reachMaxListCombo = true;
			return true;
		}
	}
	
	public int potentialCombos() {
		indexCurComb = 0;
		
		int maxit = listCombos.get(0).totalHit;
		int use = 0 ;
		for(int i = 0 ; i < listCombos.size(); i++) {
			if(maxit > listCombos.get(i).totalHit) {
				use = i;
				maxit = listCombos.get(i).totalHit;
			}
		}
		
		return use;  
	}
	
	public boolean canProcessing() {
		return !fd.getEmptyFlag() && fd.getRemainingFramesNumber() > 0;
	}
	
	public void guard() {
		if(curState == State.AIR ){
			act = Action.AIR_GUARD;
		} else if(curState == State.STAND ){
			act = Action.STAND_GUARD;
		} else {
			act = Action.CROUCH_GUARD;
		}
	}
	
	
	public Boolean useSkill() {
		if(canUseSkill) {
			//skill
			act =  Action.STAND_D_DF_FA;
			return true;
		} else {
			return false;
		}
	}
	
	public void checkDistanceX() {
		if(fd.getDistanceX() <=100 ) isNear = true;
		else isNear = false;
	}
	
	public void stateChar() {
		curState = myChar.getState();
	}
	
	public void checkSkill() {
		int energy = myChar.getEnergy();
		if(energy > 30) canUseSkill = true;
		else canUseSkill = false;
	}
	

	
	@Override
	public void roundEnd(int arg0, int arg1, int arg2) {
		key.empty();
		com.skillCancel();

	}
	
	@Override
	public void close() {

	}

}
